/*
 * W. John Thrasher
 * CAP4601
 * Research Project
 * Main cpp file
 */
 
 #include <string>
 #include <iostream>
 #include <vector>
 #include <utility>
 #include <algorithm>
 
 #include "schedule.h"

 
 
 
// How to print our std::vector:
template <typename T>
std::ostream & operator << ( std::ostream & o, std::vector<T> const & v ) {
	auto i = std::begin( v );
	auto end = std::end( v );
	o << '{';
	if ( i != end ) {
		o << ' ' << *i;
		for ( ++i; i != end; ++i ) {
			o << ", " << *i;
		}
		o << ' ';
	}
	o << '}';
	return o;
} //vector print operator

 
 int main() {

	int n{0};
	int count{0};
	
	int currentTeam{0};

	//Second int in pair indicates league
	std::vector< std::pair< std::string, int > > teams;
	std::vector< float > distances;

	//Second int in pair indicates position in teams vector
	std::vector< std::pair< std::string, int > > league0;
	std::vector< std::pair< std::string, int > > league1;


	//Get input (preferably from file redirection)
	std::cin >> n;
	while (count < (n * 2)) {
		std::string x;
		int y;
		float z;

		std::cin >> x >> y >> z;
		teams.push_back( std::make_pair(x, y) );
		distances.push_back(z);
		++count;
	}
	
	//put teams into correct leagues
	for (auto & team : teams ) {
		if (team.second == 0) {
			league0.push_back(std::make_pair(team.first, currentTeam));
		} else {
			league1.push_back(std::make_pair(team.first, currentTeam));
		}
		++currentTeam;
	}
	Schedule schedule(league0, league1, distances);
	schedule.CreateSchedule();
	schedule.Print();
	std::cout << "done\n";
 
 } //main()