/*
 * W. John Thrasher
 * CAP4601
 * Research Project
 * Class Schedule header file
 */

#ifndef SCHEDULE_H
#define SCHEDULE_H 
 
#include <vector>
#include <utility>
#include <string>

const unsigned int GROUP_SIZE{3};
 
class Schedule {
	
	typedef std::pair< std::string, int > team;
	
	public:
		Schedule() { totalDistance = 0; };
		Schedule(std::vector< team >, std::vector< team >, std::vector< float >);
		~Schedule() {};
		
		void CreateSchedule();
		void Print();

	private:
		std::vector< team > league0;
		std::vector< team > league1;
		std::vector< float > distances;
		float totalDistance;
		
		//for storing the groups
		std::vector< std::vector< team > > groups0;
		std::vector< std::vector< team > > groups1;
		
		float CalcDistance(std::vector< team >, std::vector< team >, std::vector< float >);
		std::vector< std::vector< team > > Split(std::vector< team >);
		void PrintHomeFirst(std::vector< std::vector< team > >, std::array< size_t, 3 >, size_t);
		void PrintAwayFirst(std::vector< std::vector< team > >, std::array< size_t, 3 >, size_t);

}; //end class definition		


#endif